#include <mex.h>
#include <string.h>
#include "VidHeader.h"

void mexFunction( int nlhs, mxArray *plhs[],
                  int nrhs, const mxArray *prhs[]){
	VidHeader * vid_header;
	char * fname, *buffer;
	int buflen;

	buflen = mxGetN(prhs[0])*sizeof(mxChar)+1;
	fname = new char[buflen+10];
	mxGetString(prhs[0], fname, buflen);

	//Setup the avi_helper object
	vid_header = new VidHeader(fname, stderr);
	
	buflen = sizeof(VidHeader);
	plhs[0] = mxCreateDoubleMatrix(buflen/sizeof(double)+1, 1, mxREAL);
	buffer = (char*)mxGetPr(plhs[0]);
	memcpy(buffer, vid_header, buflen);

	plhs[1] = mxCreateDoubleMatrix(3, 1, mxREAL);
	double * out = mxGetPr(plhs[1]);
	out[0] = vid_header -> width;
	out[1] = vid_header -> height;
	out[2] = (double)vid_header -> num_frames;
	delete fname;
}

